/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.resource.faults.axis;


/**
 * LOG-DONE
 * DOCUMENT_ME
 *
 * @author $author$
 * @version $Revision: 1.4 $
 */
public class _BaseFaultType_ErrorCode
   extends java.lang.Object
   implements java.io.Serializable,
              org.apache.axis.encoding.MixedContentType
{
   // Type metadata
   private static org.apache.axis.description.TypeDesc typeDesc =
      new org.apache.axis.description.TypeDesc( _BaseFaultType_ErrorCode.class, true );

   static
   {
      typeDesc.setXmlType( new javax.xml.namespace.QName( "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd",
                                                          ">BaseFaultType>ErrorCode" ) );
      org.apache.axis.description.AttributeDesc attrField = new org.apache.axis.description.AttributeDesc(  );
      attrField.setFieldName( "dialect" );
      attrField.setXmlName( new javax.xml.namespace.QName( "", "dialect" ) );
      attrField.setXmlType( new javax.xml.namespace.QName( "http://www.w3.org/2001/XMLSchema", "anyURI" ) );
      typeDesc.addFieldDesc( attrField );
   }

   private org.apache.axis.message.MessageElement[] _any; // attribute
   private org.apache.axis.types.URI                dialect; // attribute
   private java.lang.Object                         __equalsCalc   = null;
   private boolean                                  __hashCodeCalc = false;

   /**
    * Creates a new {@link _BaseFaultType_ErrorCode} object.
    */
   public _BaseFaultType_ErrorCode(  )
   {
   }

   /**
    * Creates a new {@link _BaseFaultType_ErrorCode} object.
    *
    * @param _any    DOCUMENT_ME
    * @param dialect DOCUMENT_ME
    */
   public _BaseFaultType_ErrorCode( org.apache.axis.message.MessageElement[] _any,
                                    org.apache.axis.types.URI                dialect )
   {
      this._any       = _any;
      this.dialect    = dialect;
   }

   /**
    * Get Custom Deserializer
    */
   public static org.apache.axis.encoding.Deserializer getDeserializer( java.lang.String          mechType,
                                                                        java.lang.Class           _javaType,
                                                                        javax.xml.namespace.QName _xmlType )
   {
      return new org.apache.axis.encoding.ser.BeanDeserializer( _javaType, _xmlType, typeDesc );
   }

   /**
    * Sets the dialect value for this _BaseFaultType_ErrorCode.
    *
    * @param dialect
    */
   public void setDialect( org.apache.axis.types.URI dialect )
   {
      this.dialect = dialect;
   }

   /**
    * Gets the dialect value for this _BaseFaultType_ErrorCode.
    *
    * @return dialect
    */
   public org.apache.axis.types.URI getDialect(  )
   {
      return dialect;
   }

   /**
    * Get Custom Serializer
    */
   public static org.apache.axis.encoding.Serializer getSerializer( java.lang.String          mechType,
                                                                    java.lang.Class           _javaType,
                                                                    javax.xml.namespace.QName _xmlType )
   {
      return new org.apache.axis.encoding.ser.BeanSerializer( _javaType, _xmlType, typeDesc );
   }

   /**
    * Return type metadata object
    */
   public static org.apache.axis.description.TypeDesc getTypeDesc(  )
   {
      return typeDesc;
   }

   /**
    * DOCUMENT_ME
    *
    * @param obj DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public synchronized boolean equals( java.lang.Object obj )
   {
      if ( !( obj instanceof _BaseFaultType_ErrorCode ) )
      {
         return false;
      }

      _BaseFaultType_ErrorCode other = (_BaseFaultType_ErrorCode) obj;
      if ( obj == null )
      {
         return false;
      }

      if ( this == obj )
      {
         return true;
      }

      if ( __equalsCalc != null )
      {
         return ( __equalsCalc == obj );
      }

      __equalsCalc = obj;
      boolean _equals;
      _equals =
         super.equals( obj )
         && ( ( ( this._any == null ) && ( other.get_any(  ) == null ) )
         || ( ( this._any != null ) && java.util.Arrays.equals( this._any,
                                                                other.get_any(  ) ) ) )
         && ( ( ( this.dialect == null ) && ( other.getDialect(  ) == null ) )
         || ( ( this.dialect != null ) && this.dialect.equals( other.getDialect(  ) ) ) );
      __equalsCalc = null;
      return _equals;
   }

   /**
    * Gets the _any value for this _BaseFaultType_ErrorCode.
    *
    * @return _any
    */
   public org.apache.axis.message.MessageElement[] get_any(  )
   {
      return _any;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public synchronized int hashCode(  )
   {
      if ( __hashCodeCalc )
      {
         return 0;
      }

      __hashCodeCalc = true;
      int _hashCode = super.hashCode(  );
      if ( get_any(  ) != null )
      {
         for ( int i = 0; i < java.lang.reflect.Array.getLength( get_any(  ) ); i++ )
         {
            java.lang.Object obj = java.lang.reflect.Array.get( get_any(  ),
                                                                i );
            if ( ( obj != null ) && !obj.getClass(  ).isArray(  ) )
            {
               _hashCode += obj.hashCode(  );
            }
         }
      }

      if ( getDialect(  ) != null )
      {
         _hashCode += getDialect(  ).hashCode(  );
      }

      __hashCodeCalc = false;
      return _hashCode;
   }

   /**
    * Sets the _any value for this _BaseFaultType_ErrorCode.
    *
    * @param _any
    */
   public void set_any( org.apache.axis.message.MessageElement[] _any )
   {
      this._any = _any;
   }
}