/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.resource.faults.axis;


/**
 * LOG-DONE
 * DOCUMENT_ME
 *
 * @author $author$
 * @version $Revision: 1.4 $
 */
public class _BaseFaultType_Description
   implements java.io.Serializable,
              org.apache.axis.encoding.SimpleType
{
   // Type metadata
   private static org.apache.axis.description.TypeDesc typeDesc =
      new org.apache.axis.description.TypeDesc( _BaseFaultType_Description.class, true );

   static
   {
      typeDesc.setXmlType( new javax.xml.namespace.QName( "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd",
                                                          ">BaseFaultType>Description" ) );
      org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc(  );
      elemField.setFieldName( "_value" );
      elemField.setXmlName( new javax.xml.namespace.QName( "", "_value" ) );
      elemField.setXmlType( new javax.xml.namespace.QName( "http://www.w3.org/2001/XMLSchema", "string" ) );
      typeDesc.addFieldDesc( elemField );
   }

   private java.lang.String _value;
   private java.lang.Object __equalsCalc   = null;
   private boolean          __hashCodeCalc = false;

   /**
    * Creates a new {@link _BaseFaultType_Description} object.
    */
   public _BaseFaultType_Description(  )
   {
   }

   // Simple Types must have a String constructor
   public _BaseFaultType_Description( java.lang.String _value )
   {
      this._value = _value;
   }

   /**
    * Get Custom Deserializer
    */
   public static org.apache.axis.encoding.Deserializer getDeserializer( java.lang.String          mechType,
                                                                        java.lang.Class           _javaType,
                                                                        javax.xml.namespace.QName _xmlType )
   {
      return new org.apache.axis.encoding.ser.SimpleDeserializer( _javaType, _xmlType, typeDesc );
   }

   /**
    * Get Custom Serializer
    */
   public static org.apache.axis.encoding.Serializer getSerializer( java.lang.String          mechType,
                                                                    java.lang.Class           _javaType,
                                                                    javax.xml.namespace.QName _xmlType )
   {
      return new org.apache.axis.encoding.ser.SimpleSerializer( _javaType, _xmlType, typeDesc );
   }

   /**
    * Return type metadata object
    */
   public static org.apache.axis.description.TypeDesc getTypeDesc(  )
   {
      return typeDesc;
   }

   /**
    * DOCUMENT_ME
    *
    * @param obj DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public synchronized boolean equals( java.lang.Object obj )
   {
      if ( !( obj instanceof _BaseFaultType_Description ) )
      {
         return false;
      }

      _BaseFaultType_Description other = (_BaseFaultType_Description) obj;
      if ( obj == null )
      {
         return false;
      }

      if ( this == obj )
      {
         return true;
      }

      if ( __equalsCalc != null )
      {
         return ( __equalsCalc == obj );
      }

      __equalsCalc = obj;
      boolean _equals;
      _equals =
         true
         && ( ( ( this._value == null ) && ( other.get_value(  ) == null ) )
         || ( ( this._value != null ) && this._value.equals( other.get_value(  ) ) ) );
      __equalsCalc = null;
      return _equals;
   }

   /**
    * Gets the _value value for this _BaseFaultType_Description.
    *
    * @return _value
    */
   public java.lang.String get_value(  )
   {
      return _value;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public synchronized int hashCode(  )
   {
      if ( __hashCodeCalc )
      {
         return 0;
      }

      __hashCodeCalc = true;
      int _hashCode = 1;
      if ( get_value(  ) != null )
      {
         _hashCode += get_value(  ).hashCode(  );
      }

      __hashCodeCalc = false;
      return _hashCode;
   }

   /**
    * Sets the _value value for this _BaseFaultType_Description.
    *
    * @param _value
    */
   public void set_value( java.lang.String _value )
   {
      this._value = _value;
   }

   // Simple Types must have a toString for serializing the value
   public java.lang.String toString(  )
   {
      return _value;
   }
}