/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.resource.lifetime.v1_2;

/**
 * @author Ian P. Springer
 */
public interface ResourceLifetime1_2Constants
{

   /**
    * DOCUMENT_ME
    */
   String NSURI_WSRL_SCHEMA = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd";

   /**
    * DOCUMENT_ME
    */
   String NSPREFIX_WSRL_SCHEMA = "wsrl";

   /**
    * DOCUMENT_ME
    */
   String NSURI_WSRL_WSDL = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.wsdl";

   /**
    * DOCUMENT_ME
    */
   String NSPREFIX_WSRL_WSDL = "wsrlw";

}